package com.wieseke.cptk.app;

import org.apache.log4j.xml.DOMConfigurator;
import org.eclipse.equinox.app.IApplication;
import org.eclipse.equinox.app.IApplicationContext;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;

import com.wieseke.cptk.common.preferences.PreferenceInitializer;

/**
 * This class controls all aspects of the application's execution
 */
public class CPTKApplication implements IApplication {

	public static final String APPLICATION_ID = "com.wieseke.cptk.app.CPTKApplication";

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.equinox.app.IApplication#start(org.eclipse.equinox.app.
	 * IApplicationContext)
	 */
	
	public Object start(IApplicationContext context) {

		DOMConfigurator.configure(getClass().getClassLoader().getResource(
				"config/log4j.cfg.xml"));
		Display display = PlatformUI.createDisplay();

		new PreferenceInitializer().initializeDefaultPreferences();

		try {
			int returnCode = PlatformUI.createAndRunWorkbench(display,
					new CPTKWorkbenchAdvisor());
			if (returnCode == PlatformUI.RETURN_RESTART) {
				return IApplication.EXIT_RESTART;
			}
			return IApplication.EXIT_OK;
		} finally {
			display.dispose();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.equinox.app.IApplication#stop()
	 */
	
	public void stop() {
		final IWorkbench workbench = PlatformUI.getWorkbench();
		if (workbench == null)
			return;
		final Display display = workbench.getDisplay();
		display.syncExec(new Runnable() {
			public void run() {
				if (!display.isDisposed())
					workbench.close();
			}
		});
	}
}
