package com.wieseke.cptk.app;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

import com.wieseke.cptk.common.view.CophylogenyPropertiesView;
import com.wieseke.cptk.common.view.NodePropertiesView;
import com.wieseke.cptk.output.view.ReconstructionsView;

public class CPTKPerspective implements IPerspectiveFactory {

	public void createInitialLayout(IPageLayout layout) {
		String editorAreaId = layout.getEditorArea();
		layout.setEditorAreaVisible(true);
		layout.setFixed(false);

		String leftViewAreaId = "CophylogenyToolkit.view.left";
		IFolderLayout leftViewArea = layout.createFolder(leftViewAreaId,
				IPageLayout.LEFT, 0.25f, editorAreaId);

		String navigatorViewFolderId = "CophylogenyToolkit.view.navigator";
		IFolderLayout navigatorViewFolder = layout.createFolder(
				navigatorViewFolderId, IPageLayout.TOP, 0.5f, leftViewAreaId);
		navigatorViewFolder.addView("org.eclipse.ui.navigator.CommonNavigator");

		leftViewArea.addView(NodePropertiesView.ID);
		leftViewArea.addView(CophylogenyPropertiesView.ID);
		leftViewArea.addView(ReconstructionsView.ID);

	}

}
