/**
 * 
 */
package com.wieseke.cptk.common.action;

import com.wieseke.cptk.common.api.ITreeArrangement;
import com.wieseke.cptk.input.dao.InputCophylogeny;
import com.wieseke.cptk.input.dao.InputHostNode;
import com.wieseke.cptk.input.dao.InputParasiteNode;
import com.wieseke.cptk.input.layout.LayoutFormatter;
import com.wieseke.cptk.input.viewer.InputCophylogenyViewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class RearrangeRecalculateNodeOrderAction extends CommonAction {

	/**
	 * default constructor
	 */
	public RearrangeRecalculateNodeOrderAction(String text) {
		super(text);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */

	public void run() {
		if (this.viewer != null
				&& this.viewer instanceof InputCophylogenyViewer) {
			ITreeArrangement arrangement = this.viewer.getTreeArrangement();
			InputHostNode hostRoot = ((InputCophylogenyViewer) this.viewer)
					.getCophylogeny().getHostRoot();
			InputParasiteNode parasiteRoot = ((InputCophylogenyViewer) this.viewer)
					.getCophylogeny().getParasiteRoot();
			((InputCophylogeny) this.viewer.getCophylogeny())
					.deleteNoneLeafAssociations(parasiteRoot);
			LayoutFormatter.recalculateNodeOrder(hostRoot, parasiteRoot,
					arrangement);
			this.viewer.initCophylogeny(false, arrangement);
			this.viewer.setDirty(true);
		}
	}

}