/**
 * 
 */
package com.wieseke.cptk.common.constants;

import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * @author Nicolas Wieseke
 * 
 */
public class CostsConstants {

	/**
	 * @return a map with the cost ids and texts
	 */
	public static Map<String, String> getCosts() {
		Map<String, String> costs = new LinkedHashMap<String, String>();

		costs.put(EventConstants.COSPECIATION, COSPECIATION_TEXT);
		costs.put(EventConstants.SORTING, SORTING_TEXT);
		costs.put(EventConstants.DUPLICATION, DUPLICATION_TEXT);
		costs.put(EventConstants.HOSTSWITCH, HOSTSWITCH_TEXT);

		return costs;
	}

	public final static String COSPECIATION_TEXT = "Cost value for the cospeciation event.";
	public final static BigDecimal COSPECIATION_STDCOST = new BigDecimal("0");
	public final static String SORTING_TEXT = "Cost value for the sorting event.";
	public final static BigDecimal SORTING_STDCOST = new BigDecimal("1");
	public final static String DUPLICATION_TEXT = "Cost value for the duplication event.";
	public final static BigDecimal DUPLICATION_STDCOST = new BigDecimal("2");
	public final static String HOSTSWITCH_TEXT = "Cost value for the hostswitch event.";
	public final static BigDecimal HOSTSWITCH_STDCOST = new BigDecimal("3");
	public final static String EXTINCTION_TEXT = "Cost value for the extinction event.";
	public final static double EXTINCTION_STDCOST = 1d;
}
