/**
 * 
 */
package com.wieseke.cptk.common.constants;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ViewerConstants {

	/**
	 * constant for selecting host and parasite tree
	 */
	public final static int TREE_SELECTION_BOTH = 0;
	/**
	 * constant for selecting host tree
	 */
	public final static int TREE_SELECTION_HOST = 1;
	/**
	 * constant for selecting parasite tree
	 */
	public final static int TREE_SELECTION_PARASITE = 2;
	/**
	 * constant for selecting host and parasite tree
	 */
	public final static int TREE_SELECTION_NONE = 3;

	/**
	 * the property name for the event which is fired when the content of the
	 * viewer gets dirty.
	 */
	public final static String PROPERTY_DIRTY = "DIRTY";

	/**
	 * the property name for the event which is fired when the adjust child
	 * nodes flag is changed
	 */
	public final static String PROPERTY_ADJUST_CHILD_NODES = "ADJUST_CHILD_NODES";
	/**
	 * the property name for the event which is fired when the show host label
	 * flag is changed
	 */
	public final static String PROPERTY_SHOW_HOST_LABELS = "SHOW_HOST_LABELS";
	/**
	 * the property name for the event which is fired when the show parasite
	 * label flag is changed
	 */
	public final static String PROPERTY_SHOW_PARASITE_LABELS = "SHOW_PARSITE_LABELS";
	/**
	 * the property name for the event which is fired when the show rank label
	 * flag is changed
	 */
	public final static String PROPERTY_SHOW_RANK_LABELS = "SHOW_RANK_LABELS";

}
