/**
 * 
 */
package com.wieseke.cptk.input.constants;

import java.util.regex.Pattern;

/**
 * @author Nicolas Wieseke
 * 
 */
public class InputFormatNexusConstants {

	// keywords from nexus file
	public final static String NEXUS_DIRECTIVE = "#NEXUS";
	public final static String BLOCK_BEGIN_COMMAND = "BEGIN";
	public final static String BLOCK_END_COMMAND = "ENDBLOCK";
	public final static String BLOCK_END_COMMAND_ALTERNATIVE = "END";
	public final static String TAXA_BLOCK_NAME = "TAXA";
	public final static String TAXA_BLOCK_DIMENSIONS_COMMAND = "DIMENSIONS";
	public final static String TAXA_BLOCK_DIMENSIONS_NTAX_COMMAND = "NTAX";
	public final static String TAXA_BLOCK_TAXLABELS_COMMAND = "TAXLABELS";
	public final static String TREES_BLOCK_NAME = "TREES";
	public final static String TREES_BLOCK_HOST_TREE_NAME = "HOST";
	public final static String TREES_BLOCK_PARASITE_TREE_NAME = "PARASITE";
	public final static String TREES_BLOCK_TRANSLATE_COMMAND = "TRANSLATE";
	public final static String TREES_BLOCK_TREE_COMMAND = "TREE";
	public final static String COPHYLOGENY_BLOCK_NAME = "COPHYLOGENY";
	public final static String COPHYLOGENY_BLOCK_RANKS_COMMAND = "RANKS";
	public final static String COPHYLOGENY_BLOCK_PHI_COMMAND = "PHI";
	public final static String COPHYLOGENY_BLOCK_RECONSTRUCTIONEVENTS_COMMAND = "RECONSTRUCTIONEVENTS";
	public final static String COPHYLOGENY_BLOCK_RECONSTRUCTION_COMMAND = "RECONSTRUCTION";
	public final static String COPHYLOGENY_BLOCK_COSTS_COMMAND = "COSTS";
	public final static String COPHYLOGENY_BLOCK_OPTIONS_COMMAND = "OPTIONS";
	public final static String COPHYLOGENY_BLOCK_POSITIONS_COMMAND = "POSITIONS";

	/**
	 * regular expression to determine comments
	 */
	public final static String COMMENT_PATTERN = "(\\[.*?\\])";
	/**
	 * regular expression to determine blocks
	 */
	public final static String BLOCK_PATTERN = "(^\\s*" + BLOCK_BEGIN_COMMAND
			+ "\\s+)(\\w+)(;\\s*$)(.*?)((" + BLOCK_END_COMMAND + "|"
			+ BLOCK_END_COMMAND_ALTERNATIVE + ");\\s*$)";
	public final static int BLOCK_PATTERN_FLAGS = Pattern.CASE_INSENSITIVE
			| Pattern.DOTALL | Pattern.MULTILINE;
	/**
	 * regular expression to determine commands
	 */
	public final static String COMMAND_PATTERN = "(^\\s*)(\\w+)(\\s+)(.*?)(;\\s*$)";
	public final static int COMMAND_PATTERN_FLAGS = Pattern.CASE_INSENSITIVE
			| Pattern.DOTALL | Pattern.MULTILINE;
	/**
	 * regular expression to determine one line in a command list
	 */
	public final static String COMMAND_LIST_PATTERN = "(\\s*)(.+?)(\\s*)(,|$)";
	public final static int COMMAND_LIST_PATTERN_FLAGS = Pattern.CASE_INSENSITIVE;
	/**
	 * regular expression to determine one line in a command list
	 */
	public final static String COMMAND_LIST_VALUE_PATTERN = "(('{1})((.*?)('')*)*('{1}))|([^'\\s]+)";
	public final static int COMMAND_LIST_VALUE_PATTERN_FLAGS = Pattern.CASE_INSENSITIVE;
	/**
	 * regular expression to determine a trees
	 */
	public final static String COMMAND_TREE_PATTERN = "(^\\s*)(\\*)?(\\s*)(.+?)(\\s*)(=)(\\s*)(.*?)(\\s*$)";
	public final static int COMMAND_TREE_PATTERN_FLAGS = Pattern.CASE_INSENSITIVE;
}
