/**
 * 
 */
package com.wieseke.cptk.input.model;

import com.wieseke.cptk.input.dao.InputHostNode;
import com.wieseke.cptk.input.dao.InputNode;
import com.wieseke.cptk.input.dao.InputParasiteNode;

/**
 * @author Nic
 * 
 */
public class InputNodeProperties {

	private String nodeType;
	private String label;
	private String rank;
	private String posX;
	private String posY;

	public InputNodeProperties(InputNode node) {
		this.nodeType = "";
		this.label = node.getLabel();
		this.rank = node.getRankText();
		this.posX = String.valueOf(node.getPosX());
		this.posY = String.valueOf(node.getPosY());
		if (node instanceof InputHostNode) {
			this.nodeType = "host";
		} else if (node instanceof InputParasiteNode) {
			this.nodeType = "parasite";
		}
	}

	/**
	 * @return the nodeType
	 */
	public String getNodeType() {
		return nodeType;
	}

	/**
	 * @param nodeType
	 *            the nodeType to set
	 */
	public void setNodeType(String nodeType) {
		this.nodeType = nodeType;
	}

	/**
	 * @return the label
	 */
	public String getLabel() {
		return label;
	}

	/**
	 * @param label
	 *            the label to set
	 */
	public void setLabel(String label) {
		this.label = label;
	}

	/**
	 * @return the rank
	 */
	public String getRank() {
		return rank;
	}

	/**
	 * @param rank
	 *            the rank to set
	 */
	public void setRank(String rank) {
		this.rank = rank;
	}

	/**
	 * @return the posX
	 */
	public String getPosX() {
		return posX;
	}

	/**
	 * @param posX
	 *            the posX to set
	 */
	public void setPosX(String posX) {
		this.posX = posX;
	}

	/**
	 * @return the posY
	 */
	public String getPosY() {
		return posY;
	}

	/**
	 * @param posY
	 *            the posY to set
	 */
	public void setPosY(String posY) {
		this.posY = posY;
	}

}
