package com.wieseke.cptk.input.selection;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;

import com.wieseke.cptk.input.viewer.InputNodeControl;

public class InputNodeControlSelection implements IStructuredSelection {

	private InputNodeControl inputNodeControl;

	public InputNodeControlSelection(InputNodeControl canvas) {
		this.inputNodeControl = canvas;
	}

	public InputNodeControlSelection() {
		this.inputNodeControl = null;
	}

	
	public boolean isEmpty() {
		return (inputNodeControl == null);
	}

	/**
	 * @return the inputNodeControl
	 */
	public InputNodeControl getInputNodeControl() {
		return inputNodeControl;
	}

	/**
	 * @param inputNodeControl
	 *            the inputNodeControl to set
	 */
	public void setInputNodeControl(InputNodeControl inputNodeControl) {
		this.inputNodeControl = inputNodeControl;
	}

	
	public Object getFirstElement() {
		return this.inputNodeControl;
	}

	
	public Iterator<?> iterator() {
		Iterator<InputNodeControl> iterator = new Iterator<InputNodeControl>() {
			boolean hasNext = true;

			
			public boolean hasNext() {
				return hasNext;
			}

			
			public InputNodeControl next() {
				if (hasNext) {
					hasNext = false;
					return InputNodeControlSelection.this.inputNodeControl;
				}
				return null;
			}

			
			public void remove() {
				hasNext = false;
			}
		};
		return iterator;
	}

	
	public int size() {
		return this.inputNodeControl == null ? 0 : 1;
	}

	
	public Object[] toArray() {
		InputNodeControl[] result = { this.inputNodeControl };
		return result;
	}

	
	public List<?> toList() {
		List<InputNodeControl> result = new ArrayList<InputNodeControl>();
		result.add(this.inputNodeControl);
		return result;
	}

}
