/**
 *
 */
package com.wieseke.cptk.input.viewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class InputHostParasiteNodeControlAssociation {

	private InputHostNodeControl host;
	private InputParasiteNodeControl parasite;

	public InputHostParasiteNodeControlAssociation(InputHostNodeControl host, InputParasiteNodeControl parasite) {
		this.host = host;
		this.parasite = parasite;
	}

	public InputHostParasiteNodeControlAssociation setHostParasiteAssociation(InputHostNodeControl host,
			InputParasiteNodeControl parasite) {
		InputHostParasiteNodeControlAssociation oldHostParasiteAssociation = new InputHostParasiteNodeControlAssociation(
				host, parasite);
		this.host = host;
		this.parasite = parasite;
		return oldHostParasiteAssociation;
	}

	
	public String toString() {
		return this.host.toString() + ":" + this.parasite.toString();
	}

	/**
	 * @return the host
	 */
	public InputHostNodeControl getHost() {
		return host;
	}

	/**
	 * @param host
	 *            the host to set
	 */
	public void setHost(InputHostNodeControl host) {
		this.host = host;
	}

	/**
	 * @return the parasite
	 */
	public InputParasiteNodeControl getParasite() {
		return parasite;
	}

	/**
	 * @param parasite
	 *            the parasite to set
	 */
	public void setParasite(InputParasiteNodeControl parasite) {
		this.parasite = parasite;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((host == null) ? 0 : host.hashCode());
		result = prime * result + ((parasite == null) ? 0 : parasite.hashCode());
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof InputHostParasiteNodeControlAssociation))
			return false;
		InputHostParasiteNodeControlAssociation other = (InputHostParasiteNodeControlAssociation) obj;
		if (host == null) {
			if (other.host != null)
				return false;
		} else if (!host.equals(other.host))
			return false;
		if (parasite == null) {
			if (other.parasite != null)
				return false;
		} else if (!parasite.equals(other.parasite))
			return false;
		return true;
	}

}
