/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Spinner;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ChangeParasiteRankWizardPage extends WizardPage {

	int oldValue1;
	int oldValue2;
	Spinner newValue1;
	Spinner newValue2;

	protected ChangeParasiteRankWizardPage(String pageName, int oldValue1, int oldValue2) {
		super(pageName);
		this.setTitle("Change timezone");
		this.setDescription("Enter the new timezone intervall for the node.");
		this.oldValue1 = oldValue1;
		this.oldValue2 = oldValue2;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets
	 * .Composite)
	 */
	
	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.FILL);
		GridLayout layout = new GridLayout(2, false);
		composite.setLayout(layout);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = SWT.FILL;
		gridData.grabExcessHorizontalSpace = true;
		Label labelStart = new Label(composite, SWT.NONE);
		labelStart.setText("Start timezone:");
		newValue1 = new Spinner(composite, SWT.BORDER);
		newValue1.setMinimum(0);
		newValue1.setMaximum(Integer.MAX_VALUE);
		newValue1.setLayoutData(gridData);
		newValue1.setSelection(this.oldValue1);
		Label labelEnd = new Label(composite, SWT.NONE);
		labelEnd.setText("End timezone:");
		newValue2 = new Spinner(composite, SWT.BORDER);
		newValue2.setMinimum(0);
		newValue2.setMaximum(Integer.MAX_VALUE);
		newValue2.setLayoutData(gridData);
		newValue2.setSelection(this.oldValue2);
		newValue1.addModifyListener(new ModifyListener() {
			
			public void modifyText(ModifyEvent e) {
				if (newValue1.getSelection() > newValue2.getSelection())
					newValue2.setSelection(newValue1.getSelection());
			}
		});
		newValue2.addModifyListener(new ModifyListener() {
			
			public void modifyText(ModifyEvent e) {
				if (newValue2.getSelection() < newValue1.getSelection())
					newValue1.setSelection(newValue2.getSelection());
			}
		});
		setControl(composite);
	}

	public int getValue1() {
		return newValue1.getSelection();
	}

	public int getValue2() {
		return newValue2.getSelection();
	}

}
