/**
 *
 */
package com.wieseke.cptk.input.wizards;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IExportWizard;
import org.eclipse.ui.IWorkbench;

import com.wieseke.cptk.common.viewer.CophylogenyViewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ExportSvgFileWizard extends Wizard implements IExportWizard {

	/**
	 * Logger
	 */
	static Logger logger = Logger.getLogger(ExportSvgFileWizard.class);

	ExportSvgFileWizardPage mainPage;
	CophylogenyViewer viewer;

	public ExportSvgFileWizard() {
		super();
	}

	public ExportSvgFileWizard(CophylogenyViewer viewer) {
		super();
		this.viewer = viewer;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.wizard.Wizard#performFinish()
	 */
	public boolean performFinish() {
		return mainPage.finish();
		// List<IResource> resources = (List<IResource>) mainPage
		// .getSelectedResources();
		// String destination = mainPage.getDestinationValue();
		//
		// if (!mainPage.getOverrideValue()) {
		// for (IResource rescource : resources) {
		// File svgFile = new File(destination + rescource.getFullPath()
		// + ".svg");
		// if (svgFile.exists()) {
		// mainPage.setDescription("The file " + svgFile.getName()
		// + " already exists.");
		// return false;
		// }
		// }
		// }
		//
		// for (IResource rescource : resources) {
		// try {
		// IFile file = rescource.getWorkspace().getRoot().getFile(
		// rescource.getFullPath());
		// InputStream inputStream = file.getContents();
		//
		// NexusDeserializer nexusDeserializer = new NexusDeserializer();
		//
		// InputCophylogeny cophylogeny = nexusDeserializer.deserialize(
		// inputStream, file.getName());
		// InputCophylogenyViewer viewer = new InputCophylogenyViewer(
		// getShell(), cophylogeny, "SWT Export");
		//
		// File path = new File(destination
		// + rescource.getFullPath().removeLastSegments(1));
		// if (!path.exists()) {
		// FileUtils.forceMkdir(path);
		// }
		//
		// File svgFile = new File(destination + rescource.getFullPath()
		// + ".svg");
		// svgFile.createNewFile();
		//
		// // Get a DOMImplementation.
		// DOMImplementation domImpl = GenericDOMImplementation
		// .getDOMImplementation();
		//
		// // Create an instance of org.w3c.dom.Document.
		// Document document = domImpl.createDocument(
		// "http://www.w3.org/2000/svg", "svg", null);
		//
		// // Create an instance of the SVG Generator.
		// SVGGraphics2D svgGenerator = new SVGGraphics2D(document);
		//
		// // set the size
		// svgGenerator.setSVGCanvasSize(new Dimension(viewer
		// .getMinWidth(), viewer.getMinHeight()));
		//
		// // Ask the cophylogeny to render into the SVG Graphics2D
		// // implementation.
		// viewer.paintContent(svgGenerator);
		//
		// // Finally, stream out SVG to the standard output using
		// FileWriter fw = new FileWriter(svgFile);
		// svgGenerator.stream(fw, true);
		// fw.close();
		//
		// } catch (Exception e) {
		// logger.warn("Could not convert file to SVG.", e);
		// }
		// }
		// return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench,
	 * org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		setWindowTitle("File Export Wizard"); // NON-NLS-1
		setNeedsProgressMonitor(true);
		mainPage = new ExportSvgFileWizardPage("Export SVG File", selection); // NON-NLS-1
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.wizard.IWizard#addPages()
	 */
	public void addPages() {
		super.addPages();
		addPage(mainPage);
	}

}
