/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import org.eclipse.jface.wizard.Wizard;

import com.wieseke.cptk.input.dao.InputNode;

/**
 * @author Nicolas Wieseke
 * 
 */
public class RearrangeChildPositionWizard extends Wizard {

	private RearrangeChildPositionWizardPage rearrangeChildPositionWizardPage;
	private InputNode node;
	private int[] values;

	public RearrangeChildPositionWizard(InputNode node) {
		this.node = node;
	}

	
	public boolean performFinish() {
		this.values = rearrangeChildPositionWizardPage.getValues();
		return true;
	}

	
	public void addPages() {
		String labels[] = new String[this.node.getChildren().size()];
		for (int i = 0; i < this.node.getChildren().size(); i++) {
			labels[i] = this.node.getChildren().get(i).getLabel();
		}
		rearrangeChildPositionWizardPage = new RearrangeChildPositionWizardPage("Change child positions", labels);
		addPage(rearrangeChildPositionWizardPage);
		super.addPages();
	}

	/**
	 * @return the value
	 */
	public int[] getValues() {
		return values;
	}

}
